/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clipboard", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ƥΰ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* ΰ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    /* [ԡ] --> åץܡɤ˥ǡ򥳥ԡ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, text);
    XtManageChild(copy);

    /* [ڡ] --> åץܡɤǡФ */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    char *string;
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;

    /* ƥȡåȤȤФ */
    string = XmTextGetString(text);
    if (string == NULL || *string == NULL) {
        XBell(XtDisplay(text), 0);
        return;
    }

    /* Ŭ̾ǥѥɡȥ󥰤äƤ */
    label = XmStringCreateLocalized("_my_text");

    /* åץܡɤؤΥԡ򳫻 */
    if (XmClipboardStartCopy(XtDisplay(text), XtWindow(text), label,
                             XtLastTimestampProcessed(XtDisplay(text)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(string);
        return;
    }
    /* åץܡɤ˥ǡ򥳥ԡ */
    if (XmClipboardCopy(XtDisplay(text), XtWindow(text), item_id,
                        "STRING", string, strlen(string),
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(string);
        return;
    }
    /* åץܡɤؤΥԡλ (ºݤ˥ǡž) */
    if (XmClipboardEndCopy(XtDisplay(text), XtWindow(text), item_id)
                                                  != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(string);
        return;
    }
    private_id++;
    XmStringFree(label);
    XtFree(string);
}

/* [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    unsigned long data_len;
    char *buff;
    unsigned long num_bytes;
    long private_id;

    /* (1) ǡĹĴ٤ */
    if (XmClipboardInquireLength(XtDisplay(text), XtWindow(text), "STRING",
                            &data_len) != ClipboardSuccess || data_len == 0) {
        XBell(XtDisplay(text), 0);
        return;
    }
    /* (2) ФǡХåեѰ */
    if ((buff = malloc(data_len + 1)) == NULL) {
        XBell(XtDisplay(text), 0);
        return;
    }

    /* (3) åץܡɤǡФ */
    if (XmClipboardRetrieve(XtDisplay(text), XtWindow(text),
                         "STRING", buff, data_len, &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(text), 0);
        free(buff);
        return;
    }
    buff[num_bytes] = '\0';  /* Ǹ NULL դ */

    /* åץܡɤΥǡƥȤ˥ڡ */
    XmTextSetString(text, buff);

    /* (4) ѰդХåեΰ */
    free(buff);
}
