/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define _MY_TIME    "_MY_TIME"

static void CopyCB();
static void PasteCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, clock, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clipnewform", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ɽ٥ */
    ac = 0;
    clock = XmCreateLabel(panel, "clock", al, ac);
    XtManageChild(clock);

    /* ΰ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    /* [ԡ] --> åץܡɤ˥ǡ򥳥ԡ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, clock);
    XtManageChild(copy);

    /* [ڡ] --> åץܡɤǡФ */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, clock);
    XtManageChild(paste);

    /* (1) եޥåȤϿ */
    if (XmClipboardRegisterFormat(XtDisplay(toplevel), _MY_TIME, 32)
                                                    != ClipboardSuccess) {
        fprintf(stderr, "Cannot register format %s\n", _MY_TIME);
        exit(1);
    }

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget clock = (Widget)client_data;
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;
    time_t current;
    char *time_str;
    XmString string;

    /* ߤλͤĴ٤ */
    current = time(NULL);

    /* ߤλʸѴƥ٥ɽ */
    time_str = ctime(&current);
    if (time_str[strlen(time_str) - 1] == '\n')
        time_str[strlen(time_str) - 1] = '\0';
    string = XmStringCreateLocalized(time_str);
    XtVaSetValues(clock, XmNlabelString, string, NULL);
    XmStringFree(string);

    /* Ŭ̾ǥѥɡȥ󥰤äƤ */
    label = XmStringCreateLocalized("_my_clock");

    /* åץܡɤؤΥԡ򳫻 */
    if (XmClipboardStartCopy(XtDisplay(clock), XtWindow(clock), label,
                             XtLastTimestampProcessed(XtDisplay(clock)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(clock), 0);
        XmStringFree(label);
        return;
    }
    /* (2) եޥåȤǥåץܡɤ˥ǡ򥳥ԡ */
    if (XmClipboardCopy(XtDisplay(clock), XtWindow(clock), item_id,
                        _MY_TIME, &current, sizeof(current),
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(clock), XtWindow(clock), item_id);
        XBell(XtDisplay(clock), 0);
        XmStringFree(label);
        return;
    }
    /* åץܡɤؤΥԡλ (ºݤ˥ǡž) */
    if (XmClipboardEndCopy(XtDisplay(clock), XtWindow(clock), item_id)
                                                  != ClipboardSuccess) {
        XBell(XtDisplay(clock), 0);
        XmStringFree(label);
        return;
    }
    private_id++;
    XmStringFree(label);
}

/* [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget clock = (Widget)client_data;
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    time_t copied_time;
    char *time_str;
    XmString string;

    /* (3) åץܡɤ鿷եޥåȤΥǡФ */
    if (XmClipboardRetrieve(XtDisplay(clock), XtWindow(clock),
                      _MY_TIME, &copied_time, sizeof(copied_time), &num_bytes,
                      &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(clock), 0);
        return;
    }

    /* ФͤʸѴƥ٥ɽ */
    time_str = ctime(&copied_time);
    if (time_str[strlen(time_str) - 1] == '\n')
        time_str[strlen(time_str) - 1] = '\0';
    string = XmStringCreateLocalized(time_str);
    XtVaSetValues(clock, XmNlabelString, string, NULL);
    XmStringFree(string);
}
